
// fixes around 30 bugs of tigcc
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

int main (void)
{
    FILE *in, *out;
    char buffer[256], inst[256], first[256], second[256];
    int  i, j;
    int  new_bsrs = 0, fixbugs = 0;

    in = fopen ("ontic.s", "r");
    out = fopen ("newasm.s", "w");

    while (!feof (in))
    {

        if (fgets (buffer, 256, in) == NULL) break;

        if (strcmp (buffer, ".data\n") == 0) continue;
        if (!isspace (buffer[0]))
        {
           fputs (buffer, out);
           continue;
        }

        // extract instruction
        i = 1;
        while (isspace (buffer[i])) i++;
        while (!isspace (buffer[i]))
        {
           inst[i - 1] = buffer[i];
           inst[i] = '\0';
           i++;

        }
        if (buffer[i] == '\n')
        {
           fputs (buffer, out);
           continue;
        } // if
        i++;
        j = i;
        while (buffer[i] != ',' && !isspace (buffer[i]))
        {
           first[i - j] = buffer[i];
           first[i - j + 1] = '\0';
           i++;
        } // while
        if (isspace(buffer[i]))
        {
           // probably a jsr instruction
           #if 0
           if (strcmp (inst, "jsr") == 0)
           {
              // is it a library
              if (strstr (first, "__0") != NULL || strncmp (first, "_ROM_", 5) == 0)
              {
                 fputs (buffer, out);
                 continue;
              } else {
                 if (first[0] == '(')
                    fputs (buffer, out);
                 else {
                    fprintf (out, "\tbsr %s\n", first);
                    new_bsrs++;
                 }
                 continue;
              } // if
           } else {
              fputs (buffer, out);
              continue;
           } // if
           #else
              fputs (buffer, out);
              continue;
           #endif
        } // if

        // extract second instruction
        i++;
        j = i;
        while (!isspace (buffer[i]))
        {
           second[i - j] = buffer[i];
           second[i - j + 1] = '\0';
           i++;
        } // while
        if (strcmp (inst, "move.w") == 0 || strcmp (inst, "cmp.w") == 0)
        {
           if (strncmp (second, "%a", 2) == 0 || strncmp (first, "%a", 2) == 0)
           {
              if (first[0] != '%')
              {
                 fputs (buffer, out);
                 continue;
              }
              fixbugs++;
              if (strcmp (inst, "move.w") == 0)
              {
                 fprintf (out, "\tmove.l %s,%s\n", first, second);
                 continue;
              } else {
                 fprintf (out, "\tcmp.l %s,%s\n", first, second);
                 continue;
              } // if
           } else {
              fputs (buffer, out);
              continue;
           } // if
        } else {
           fputs (buffer, out);
           continue;
        } // if
    } // while

    printf ("replaced %d jsr instructions by a bsr instruction\n"
            "fixed %d tigcc's bugs\n", new_bsrs, fixbugs);
    fclose (in);
    fclose (out);

    return 0;
} // main


