#ifndef __MEM
#define __MEM

#ifndef NOSTUB
#ifndef DOORS
#error: Neither "nostub.h" nor "doors.h" is included!
#endif
#endif

#undef size_t
#define size_t unsigned long

#undef NULL
#define NULL ((void*)0)

#define memcpy _rom_call(void*,(void*,void*,long),26A)
#define memchr _rom_call(void*,(void*,int,long),273)
#define memmove _rom_call(void*,(void*,void*,long),26B)
#define memcmp _rom_call(long,(void*,void*,long),270)
#define memset _rom_call(void*,(void*,int,long),27C)
#define _memset _rom_call(void*,(void*,int,long),27B)

#ifdef DOORS

void *memcpy(void*,void*,long);
void *memchr(void*,int,long);
void *memmove(void*,void*,long);
long memcmp(void*,void*,long);
void *memset(void*,int,long);
void *_memset(void*,int,long);

#endif

#endif
