/*
 *	68000 C compiler
 *
 *	Copyright 1984, 1985, 1986 Matthew Brandt.
 *  all commercial rights reserved.
 *
 *	This compiler is intended as an instructive tool for personal use. Any
 *	use for profit without the written consent of the author is prohibited.
 *
 *	This compiler may be distributed freely for non-commercial use as long
 *	as this notice stays intact. Please forward any enhancements or questions
 *	to:
 *
 *		Matthew Brandt
 *		Box 920337
 *		Norcross, Ga 30092
 */

/*      global declarations     */

FILE             *input,
                        *list,
                        *output;

int              lineno;
int              nextlabel;
int              lastch;
int              lastst;
char             lastid[20];
char             laststr[MAX_STLP1];
long             ival;
/* extern double           rval; */
long		rval;

TABLE            gsyms,
                        lsyms;
SYM              *lasthead;
struct slit      *strtab;
int              lc_static;
int              lc_auto;
struct snode     *bodyptr;       /* parse tree for function */
int              global_flag;
TABLE            defsyms;
int              save_mask;      /* register save mask */