#include "mem.h"

#ifndef __STRING
#define __STRING

#define sprintf _rom_call(int,(char*,char*,...),53)
#define strcpy _rom_call(char*,(char*,char*),26C)
#define strncpy _rom_call(char*,(char*,char*,long),26D)
#define strcat _rom_call(char*,(char*,char*),26E)
#define strncat _rom_call(char*,(char*,char*,long),26F)
#define strcmp _rom_call(long,(char*,char*),271)
#define strncmp _rom_call(int,(char*,char*,long),272)
#define strlen _rom_call(unsigned long,(char*),27E)
#define strchr _rom_call(char*,(char*,int),274)
#define strcspn _rom_call(unsigned long,(char*,char*),275)
#define strpbrk _rom_call(char*,(char*,char*),276)
#define strrchr _rom_call(char*,(char*,int),277)
#define strspn _rom_call(unsigned long,(char*,char*),278)
#define strstr _rom_call(char*,(char*,char*),279)
#define strtok _rom_call(char*,(char*,char*),27A)
#define strerror _rom_call(char*,(int),27D)

#ifdef DOORS

int sprintf(char*,char*,...);
char *strcpy(char*,char*);
char *strncpy(char*,char*,long);
char *strcat(char*,char*);
char *strncat(char*,char*,long);
int strcmp(char*,char*);
int strncmp(char*,char*,long);
unsigned long strlen(char*);
char *strchr(char*,int);
unsigned long strcspn(char*,char*);
char *strpbrk(char*,char*);
char *strrchr(char*,int);
unsigned long strspn(char*,char*);
char *strstr(char*,char*);
char *strtok(char*,char*);
char *strerror(int);

#endif

#endif
